****************************************************************************************************			
* Pantalla "std" 	$0c00-$23ff - SAM offset = $0c00 / $200 =  $6 = #%0000110 - valor por defecto
* buffer				$2400-3bff	- SAM offset = $2400 / $200 = $18 = #%0010010
****************************************************************************************************			
			opt	cd
			opt	ct
			org	$4500					; donde ubicar el programa
inicio	orcc	#$50					; deshabilita interrupciones
			lda	#$5					; poner a uno los bits 0 y 2
			sta	$ff03					; para detectar FS al final de pantalla
			ldx	#$0c00				; origen de pantalla (inicial donde est imagen a mover)
			stx	origen				; guardar puntero
			ldy	#$2400				; destino sin desplazar
			sty	destino				; guardar puntero
			ldb	#192					; filas a desplazar para mover toda la pantalla
			stb	<$76					; guardar en variable pagina 0
L1			leax	32,x
			lda	#191					; numero de lineas a hacer scroll (la ltima NO)
			sta	<$77					; guardar en variable pagina 0

			opt	cc
m1L		ldu	,x
			stu	,y					;  2 bytes copiados
			ldu	2,x
			stu	2,y					;  4 bytes copiados
			ldu	4,x
			stu	4,y					;  6 bytes copiados
			ldu	6,x
			stu	6,y					;  8 bytes copiados
			ldu	8,x
			stu	8,y					; 10 bytes copiados
			ldu	10,x
			stu	10,y					; 12 bytes copiados
			ldu	12,x
			stu	12,y					; 14 bytes copiados
			ldu	14,x
			stu	14,y					; 16 bytes copiados
			leax	16,x
			leay	16,y
			ldu	,x
			stu	,y						; 18 bytes copiados
			ldu	2,x
			stu	2,y					; 20 bytes copiados
			ldu	4,x
			stu	4,y					; 22 bytes copiados
			ldu	6,x
			stu	6,y					; 24 bytes copiados
			ldu	8,x
			stu	8,y					; 26 bytes copiados
			ldu	10,x
			stu	10,y					; 28 bytes copiados
			ldu	12,x
			stu	12,y					; 30 bytes copiados
			ldu	14,x
			stu	14,y					; 32 bytes copiados = 1 linea completa
			leax	16,x
			leay	16,y
			dec 	<$77					; movidas todas las lneas?
			bne	m1L					; no, hacer siguiente lnea

			opt	cc
			ldu	<$8a					; tomar doble cero
			stu	,y						; 2
			stu	2,y					; 4
			stu	4,y					; 6
			stu	6,y					; 8 
			stu	8,y					;10
			stu	10,y					;12
			stu	12,y					;14
			stu	14,y					;16
			leay	16,y
			stu	,y						;18
			stu	2,y					;20
			stu	4,y					;22
			stu	6,y					;24
			stu	8,y					;26
			stu	10,y					;28
			stu	12,y					;30
			stu	14,y					; limpiar los 32 bytes de la ultima linea

			opt	cc
eHs		lda	$ff03					; lleg interrupcin HSYNC? (la de final de pantalla!)
			bpl	eHs					; esperar
			lda	$ff02					; limpiar indicador de interrupcin
											; cambiar inicio de pantalla en SAM
cambio	lda	<$76					; lee contador numero de scrolls a realizar (+1)
			anda	#1						; usa bit cero
			beq	par					; si es par mostrar buffer
											; si es impar mostrar 'std'
impar		sta	$ffcb					; 1
			sta	$ffce					; 0 = #%0000110 = 6 (valor x defecto)
			bra	actPun				; salta codigo para Pares
par		sta	$ffca					; 0
			sta	$ffcf					; 1 = #%0010010 = 18 (valor x buffer)
											; cambiar punteros
actPun	ldx	destino				; toma destino (nuevo origen)
			ldy	origen				; toma origen (nuevo destino)
			sty	destino				; actualiza destino actual
			stx	origen				; actualiza origen actual
			dec	<$76					; movida la imagen completa?
			lbne	L1						; no, siguiente pixel abajo

			opt	cc
			andcc	#$af					; habilita interrupciones
			rts							; retorna
****************************************************************************************************
origen	fdb	$0000
destino	fdb	$0000
			end 	inicio
